hdu 1260 Tickets

来源:互联网 发布:js 数组函数 编辑:程序博客网 时间:2024/06/06 19:42
Jesus, what a great movie! Thousands of people are rushing to the cinema. However, this is really a tuff time for Joe who sells the film tickets. He is wandering when could he go back home as early as possible.A good approach, reducing the total time of tickets selling, is let adjacent people buy tickets together. As the restriction of the Ticket Seller Machine, Joe can sell a single ticket or two adjacent tickets at a time.Since you are the great JESUS, you know exactly how much time needed for every person to buy a single ticket or two tickets for him/her. Could you so kind to tell poor Joe at what time could he go back home as early as possible? If so, I guess Joe would full of appreciation for your help.

Input

There are N(1<=N<=10) different scenarios, each scenario consists of 3 lines:1) An integer K(1<=K<=2000) representing the total number of people;2) K integer numbers(0s<=Si<=25s) representing the time consumed to buy a ticket for each person;3) (K-1) integer numbers(0s<=Di<=50s) representing the time needed for two adjacent people to buy two tickets together.

Output

For every scenario, please tell Joe at what time could he go back home as early as possible. Every day Joe started his work at 08:00:00 am. The format of time is HH:MM:SS am|pm.

Sample Input

2220 254018 

Sample Output

08:00:40 am08:00:08 am 

【题意】现在有很多人在排队,你在队尾,每个人都要买票,都需要相同或者不同的时间,现在呢,人们都听你的建议,你可以让相邻的两个人一起买,你呢,想最快的买完票,问最短时间是多少。

【分析】经典的dp问题,显然对于当前人数来说只有两种情况,和前面的人合作,或者自己买,所以就得到了转移方程:
dp[i]=min(dp[i-1]+num1[i],dp[i-2]+num2[i]);

【代码】

#include <bits/stdc++.h>using namespace std;int num1[2005];int num2[2005];int dp[2005];void pri(int x)//注意一下输出就行{    int hh = x/3600;    int mm = x%3600/60;    int ss = x%60;    printf("%02d:%02d:%02d%s\n", (8+hh)%24, mm, ss, (hh+8)%24>12?" pm":" am");}int main (void){    int T;    scanf("%d",&T);    while(T--)    {        int len;        scanf("%d",&len);        if(len==1)        {            scanf("%d",&num1[0]);            pri(num1[0]);            continue;        }        for(int i=0; i<len; i++)            scanf("%d",num1+i);        for(int i=1; i<len; i++)            scanf("%d",num2+i);        dp[0]=num1[0];        dp[1]=min(num1[0]+num1[1],num2[1]);        for(int i=2; i<len; i++)            dp[i]=min(dp[i-2]+num2[i],dp[i-1]+num1[i]);        int ans=dp[len-1];        pri(ans);    }    return 0;}
原创粉丝点击